//=============================================================================
// MPU ý 
//
// by nexp76(nexp76@naver.com) http://cafe.naver.com/elab
// [config.h]
//=============================================================================

/*
  - Driver Cinfiguration Define
*/
#define ewarm

#include "../hw_ints.h"
#include "../hw_memmap.h"
#include "../hw_types.h"
#include "sysctl.h"
#include "debug.h"
#include "gpio.h"
#include "uart.h"

//-----------------------------------------------------------------------------
// UTILITY DEFINATION
#define Sbi(Port, Value)        	(Port |= Value)
#define Cbi(Port, Value)            (Port &= (~Value))
#define Tbi(Port, Value)            (Port ^= Value)

#define MSB(x)    					(((x) >> 8) & 0xFF)
#define LSB(x)    					((x) & 0xFF)
#define ABS(x)						((x<0)?x:x*=-1))

//#define TRUE						1
//#define FALSE						0

#define BIT0						0x01
#define BIT1						0x02
#define BIT2						0x04
#define BIT3						0x08
#define BIT4						0x10
#define BIT5						0x20
#define BIT6						0x40
#define BIT7						0x80
#define BIT8						0x0100
#define BIT9						0x0200
#define BIT10						0x0400
#define BIT11						0x0800
#define BIT12						0x1000
#define BIT13						0x2000
#define BIT14						0x4000
#define BIT15						0x8000
//-----------------------------------------------------------------------------


#define _UART0_ENABLE
//UART1 ϱ 
//#define _UART0_ENABLE


//-----------------------------------------------------------------------------
#if 1
//#define U0_printf						printf
#define DebugPrint						U0_printf
#define DebugInit						U0_Init
#define DebugGetByte					U0_GetByte
#define DebugIsByte						U0_IsGetByte
#endif

#if 0
#define DebugPrint						printf
#define DebugInit						U1_Init
#define DebugGetByte					U1_GetByte
#define DebugIsByte						U1_IsGetByte
#endif
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//LED Driver
#define LED1_BIT						BIT0
#define LED1_PORT						GPIO_PORTE_DATA_R
#define Led1Init()						
#define Led1Off()						Sbi(LED1_PORT, LED1_BIT)
#define Led1On()						Cbi(LED1_PORT, LED1_BIT)
#define Led1Toggle()					Tbi(LED1_PORT, LED1_BIT)

#define LED2_BIT						BIT1
#define LED2_PORT						GPIO_PORTE_DATA_R
#define Led2Init()						Sbi(LED1_PORT, LED2_BIT)
#define Led2Off()						Cbi(LED1_PORT, LED2_BIT)
#define Led2On()						Tbi(LED1_PORT, LED2_BIT)
#define Led2Toggle()					

#define Led1Init() 						(SYSCTL_RCGC2_R |= SYSCTL_RCGC2_GPIOE);\
										Sbi(GPIO_PORTE_DIR_R, LED1_BIT);Sbi(GPIO_PORTE_DEN_R, LED1_BIT)	

#define Led2Init() 						(SYSCTL_RCGC2_R |= SYSCTL_RCGC2_GPIOE);\
										Sbi(GPIO_PORTE_DIR_R, LED2_BIT);Sbi(GPIO_PORTE_DEN_R, LED2_BIT)	
 
 	
//-----------------------------------------------------------------------------
//Switch Driver
#define SW1_BIT							BIT7
#define SW1_PORT						GPIO_PORTC_DATA_R
#define Sw1Init()						(SYSCTL_RCGC2_R |= SYSCTL_RCGC2_GPIOC);\
										Cbi(GPIO_PORTC_DIR_R, LED1_BIT);Sbi(GPIO_PORTC_DEN_R, SW1_BIT)

#define GetSw1()						(GPIO_PORTC_DATA_R&SW1_BIT)
#define WaitForSw1()					while(GetSw1())

//-----------------------------------------------------------------------------
//GPDIO Data
#define PORTA							GPIOA->ODR
#define PORTB							GPIOB->ODR
#define PORTC							GPIOC->ODR


#define PORTB_MASK						0xFF	
#define PortBOut(Data)					PORTB = (Data&PORTB_MASK)|(PORTB & ~PORTB_MASK)
#define PortBIn()						(PORTB&PORTB_MASK)	

#define InitPortB()						RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB|RCC_APB2Periph_AFIO, ENABLE);\
										GPIO_InitStructure.GPIO_Pin = PORTB_MASK;\
										GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;\
										GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;\
										GPIO_Init(GPIOB, &GPIO_InitStructure);\
										GPIO_PinRemapConfig(GPIO_Remap_SWJ_Disable, ENABLE);

#define CTRL_BIT0						BIT11
#define CTRL_BIT1						BIT12
#define CTRL_BIT2						BIT13

#define CtrlInit() 						RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);\
										GPIO_InitStructure.GPIO_Pin = CTRL_BIT0|CTRL_BIT1|CTRL_BIT2;\
										GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;\
										GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;\
										GPIO_Init(GPIOA, &GPIO_InitStructure)\
										GPIO_ResetBits(GPIOA, CTRL_BIT0|CTRL_BIT1|CTRL_BIT2)\
										

#define CtrlLatch0()					GPIO_SetBits(GPIOA, CTRL_BIT0);GPIO_ResetBits(GPIOA, CTRL_BIT0)
#define CtrlLatch1()					GPIO_SetBits(GPIOA, CTRL_BIT1);GPIO_ResetBits(GPIOA, CTRL_BIT1)
#define CtrlLatch2()					GPIO_SetBits(GPIOA, CTRL_BIT2);GPIO_ResetBits(GPIOA, CTRL_BIT2)

#define ADDR_LCD						0x00
#define ADDR_CTL						0x01
#define ADDR_FND						0x02





//-----------------------------------------------------------------------------
#define SPI0_SS_BIT						BIT0
#define SPI0_SS_DDR						DDRB
#define SPI0_SS_PORT					PORTB

#define SPI0_SCLK_BIT					BIT1
#define SPI0_SCLK_DDR					DDRB
#define SPI0_SCLK_PORT					PORTB

#define	SPI0_MOSI_BIT					BIT2
#define SPI0_MOSI_DDR					DDRB
#define SPI0_MOSI_PORT					PORTB

#define	SPI0_MISO_BIT					BIT3
#define SPI0_MISO_DDR					DDRB
#define SPI0_MISO_PORT					PORTB


#define IINCHIP_SpiInit					SPI0_Init
#define IINCHIP_SpiSendData				SPI0_SendByte	
#define IINCHIP_SpiRecvData				SPI0_RxData

#define IINCHIP_CS_BIT					BIT0
#define IINCHIP_CS_DDR					DDRB
#define IINCHIP_CS_PORT					PORTB

#define IINCHIP_CSInit()				Sbi(IINCHIP_CS_DDR, IINCHIP_CS_BIT)
#define IINCHIP_CSon()					Sbi(IINCHIP_CS_PORT, IINCHIP_CS_BIT)
#define IINCHIP_CSoff()					Cbi(IINCHIP_CS_PORT, IINCHIP_CS_BIT)
//-----------------------------------------------------------------------------



#define WIZNET_A0						BIT8	//PB8
#define WIZNET_A1						BIT9	//PB9
#define RD								BIT13	//PC13
#define WR								BIT12	//PC12
#define WIZNET_CS						BIT15	//PA15

#define WIZNET_CS_ON()					GPIO_SetBits(GPIOA, WIZNET_CS)
#define WIZNET_CS_OFF()					GPIO_ResetBits(GPIOA, WIZNET_CS)

#define WIZNET_A0_ON()					GPIO_SetBits(GPIOB, WIZNET_A0)
#define WIZNET_A0_OFF()					GPIO_ResetBits(GPIOB, WIZNET_A0)
#define WIZNET_A1_ON()					GPIO_SetBits(GPIOB, WIZNET_A1)
#define WIZNET_A1_OFF()					GPIO_ResetBits(GPIOB, WIZNET_A1)

#define WIZNET_RD_ON()					GPIO_SetBits(GPIOC, RD)
#define WIZNET_RD_OFF()					GPIO_ResetBits(GPIOC, RD)
#define WIZNET_WR_ON()					GPIO_SetBits(GPIOC, WR)
#define WIZNET_WR_OFF()					GPIO_ResetBits(GPIOC, WR)
